% Demo for CovarFARIMA0D0

% length of synthesized process
N = 2^10; 

% set parameters for the FARIMA(0,D,0) model
W = [1 2;0 1];
d = [0.1 0.2];
Sigmae = eye(2);

% generate covariance structure
Ncov = N+1; % cov. could be asymmetric, get cov. seq. of length N+1
R = CovarFARIMA0D0(Ncov,d,W,Sigmae);

% generate bivariate sequence

% There are two functions that can achive this.
% First example: Function tailored for bivariate synthesis (for P=2)
tic
[X1,Y1] = GenBivarGauss(R,N);
time_GenBivarGauss = toc

% Second example: More general function (for P>=2)
tic
X = GenMultivarGauss(R,N);
time_GenMultivarGauss = toc
X1 = X(1,:); X2 = X(2,:);

% plot the auto- and cross-covariance sequences
figure;
subplot(311); plotcovar(R,1,1); axis([-80 80 0 1.5]);
subplot(312); plotcovar(R,2,2); axis([-80 80 0 1.5]);
subplot(313); plotcovar(R,1,2); axis([-80 80 0 0.3]);

% plot a realization of the process
figure;
subplot(211);plot(X1);xlabel('n');ylabel('X_1[n]');
subplot(212);plot(X2);xlabel('n');ylabel('X_2[n]');