% Demo for plotCovMapHermite

% create function handles
sigma = 1; mu = 0;
funch1 = @(x) logninv(normcdf(x),mu,sigma); % lognormal marginal
mu2 = 2;
funch2 = @(x) expinv(normcdf(x),mu2); % exponential marginal

% plot forward covariance mapping for each coordinate pair, (1,1), (1,2), (2,2)
figure(1); clf;
plotCovMapHermite(funch1,funch1);
xlabel('r^X_{1,1}'); ylabel('r^Y_{1,1}');

figure(2); clf;
plotCovMapHermite(funch2,funch2);
xlabel('r^X_{2,2}'); ylabel('r^Y_{2,2}');

figure(3); clf;
plotCovMapHermite(funch1,funch2);
xlabel('r^X_{1,2}'); ylabel('r^Y_{1,2}');

% plot correlation mapping (normalized with variance of coordinates involved)
plotCorr = 1;

figure(21); clf;
plotCovMapHermite(funch1,funch1,plotCorr);
xlabel('r^X_{1,1}'); ylabel('\rho^Y_{1,1}');
axis([-1 1 -1 1]);

figure(22); clf;
plotCovMapHermite(funch2,funch2,plotCorr);
xlabel('r^X_{2,2}'); ylabel('\rho^Y_{2,2}');
axis([-1 1 -1 1]);

figure(32); clf;
plotCovMapHermite(funch1,funch2,plotCorr);
xlabel('r^X_{1,2}'); ylabel('\rho^Y_{1,2}');
axis([-1 1 -1 1]);

% plot reversion and forward mapping on the same plot
plotReversion = 1;

figure(41); clf;
plotCovMapHermite(funch1,funch1,plotCorr); 
hold on;
plotCovMapHermite(funch1,funch1,plotCorr,plotReversion);
xlabel('r^X_{1,1}'); ylabel('\rho^Y_{1,1}');
axis([-1 1 -1 1]);
legend('forward','reversion','Location','Best');

figure(42); clf;
plotCovMapHermite(funch2,funch2,plotCorr); 
hold on;
plotCovMapHermite(funch2,funch2,plotCorr,plotReversion);
xlabel('r^X_{2,2}'); ylabel('\rho^Y_{2,2}');
axis([-1 1 -1 1]);
legend('forward','reversion','Location','Best');

figure(43); clf;
plotCovMapHermite(funch1,funch2,plotCorr); 
hold on;
plotCovMapHermite(funch1,funch2,plotCorr,plotReversion);
xlabel('r^X_{1,2}'); ylabel('\rho^Y_{1,2}');
axis([-1 1 -1 1]);
legend('forward','reversion','Location','Best');